/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2017
* 
*        (as is).
*     .
********************************************************************************
*/


#ifndef __BOARD_H
#define __BOARD_H

#include "stm32f042x6.h"

//OUTs
#define       OUT_1_PIN                    1
#define       OUT_1_GPIO                   GPIOB
#define       OUT_2_PIN                    0
#define       OUT_2_GPIO                   GPIOB
#define       OUT_3_PIN                    7
#define       OUT_3_GPIO                   GPIOB
#define       OUT_4_PIN                    5
#define       OUT_4_GPIO                   GPIOB
#define       OUT_5_PIN                    15
#define       OUT_5_GPIO                   GPIOA
#define       OUT_6_PIN                    10
#define       OUT_6_GPIO                   GPIOA
#define       OUT_7_PIN                    9
#define       OUT_7_GPIO                   GPIOA
#define       OUT_8_PIN                    8
#define       OUT_8_GPIO                   GPIOA

//config
#define       CONFIG_1_PIN                 13
#define       CONFIG_2_PIN                 14

// 
#define       TOUCH_GPIO                   GPIOA
#define       TOUCH_GROUP_3_GPIO           GPIOB
#define       TOUCH_SAMPLING_PIN_1         0
#define       TOUCH_SAMPLING_PIN_2         4
#define       TOUCH_SAMPLING_PIN_3         3
#define       TOUCH_CHANNEL_1_PIN          1
#define       TOUCH_CHANNEL_2_PIN          2
#define       TOUCH_CHANNEL_3_PIN          3
#define       TOUCH_CHANNEL_4_PIN          5
#define       TOUCH_CHANNEL_5_PIN          6
#define       TOUCH_CHANNEL_6_PIN          7
#define       TOUCH_CHANNEL_7_PIN          4
#define       TOUCH_CHANNEL_8_PIN          6
#define       TOUCH_AF                     3

#define       TOUCH_CHANNELS_NUM           8
#define       TOUCH_THRESHOLD              3





void Init();

void Sensor_IRQ();

#endif //__BOARD_H


