/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2017
* 
*        (as is).
*     .
********************************************************************************
*/

#include "board.h"


//static volatile uint8_t SensorData = 0;

uint8_t Mode;


void main()
{
  Init();
  
  for(;;)
  {
    
  }
}
//------------------------------------------------------------------------------
void Init()
{
/*  
  //HSI, PLL, 48 MHz
  FLASH->ACR = FLASH_ACR_PRFTBE | (uint32_t)FLASH_ACR_LATENCY;
  // HCLK = SYSCLK / 1
  RCC->CFGR |= (uint32_t)RCC_CFGR_HPRE_DIV1;
  // PCLK2 = HCLK / 1
  RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE_DIV1;
  //  PLL: (HSI / 2) * 12 = (8 / 2) * 12 = 48 ()
  //RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMUL));
  RCC->CFGR |= (uint32_t)(RCC_CFGR_PLLSRC_HSI_DIV2 | RCC_CFGR_PLLMUL12);

  RCC->CR |= RCC_CR_PLLON;

  while((RCC->CR & RCC_CR_PLLRDY) == 0);
  
  RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_SW));
  RCC->CFGR |= (uint32_t)RCC_CFGR_SW_PLL;

  while ((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)RCC_CFGR_SWS_PLL);
*/  
  RCC->AHBENR |= RCC_AHBENR_GPIOAEN | RCC_AHBENR_GPIOBEN;
  
 
  GPIOA->MODER &= ~((3 << (2 * CONFIG_1_PIN)) | (3 << (2 * CONFIG_2_PIN)));
  GPIOA->PUPDR &= ~((3 << (2 * CONFIG_1_PIN)) | (3 << (2 * CONFIG_2_PIN)));
  GPIOA->PUPDR |= ((1 << (2 * CONFIG_1_PIN)) | (1 << (2 * CONFIG_2_PIN)));
  
  GPIOA->MODER |= ((1 << (2 * OUT_8_PIN)) | (1 << (2 * OUT_7_PIN)) | (1 << (2 * OUT_5_PIN)) | (1 << (2 * OUT_6_PIN)));
  GPIOA->ODR |= (1 << OUT_8_PIN) | (1 << OUT_7_PIN) | (1 << OUT_5_PIN) | (1 << OUT_6_PIN);
  GPIOB->MODER |= ((1 << (2 * OUT_1_PIN)) | (1 << (2 * OUT_2_PIN)) | (1 << (2 * OUT_4_PIN)) | (1 << (2 * OUT_3_PIN)));
  GPIOB->ODR |= (1 << OUT_1_PIN) | (1 << OUT_2_PIN) | (1 << OUT_4_PIN) | (1 << OUT_3_PIN);
  
  // 
  TOUCH_GPIO->OTYPER |= (1 << TOUCH_SAMPLING_PIN_1) | (1 << TOUCH_SAMPLING_PIN_2);
  TOUCH_GPIO->MODER |= ((2 << (2 * TOUCH_SAMPLING_PIN_1)) | (2 << (2 * TOUCH_CHANNEL_1_PIN)) | \
                        (2 << (2 * TOUCH_CHANNEL_2_PIN)) | (2 << (2 * TOUCH_CHANNEL_3_PIN)) | \
                        (2 << (2 * TOUCH_SAMPLING_PIN_2)) | (2 << (2 * TOUCH_CHANNEL_4_PIN)) | \
                        (2 << (2 * TOUCH_CHANNEL_5_PIN)) | (2 << (2 * TOUCH_CHANNEL_6_PIN)));
  TOUCH_GPIO->AFR[0] |= (TOUCH_AF << (4 * TOUCH_SAMPLING_PIN_1)) | (TOUCH_AF << (4 * TOUCH_CHANNEL_1_PIN)) | \
                        (TOUCH_AF << (4 * TOUCH_CHANNEL_2_PIN)) | (TOUCH_AF << (4 * TOUCH_CHANNEL_3_PIN)) | \
                        (TOUCH_AF << (4 * TOUCH_SAMPLING_PIN_2)) | (TOUCH_AF << (4 * TOUCH_CHANNEL_4_PIN)) | \
                        (TOUCH_AF << (4 * TOUCH_CHANNEL_5_PIN)) | (TOUCH_AF << (4 * TOUCH_CHANNEL_6_PIN));
  
  TOUCH_GROUP_3_GPIO->OTYPER |= (1 << TOUCH_SAMPLING_PIN_3);
  TOUCH_GROUP_3_GPIO->MODER |= ((2 << (2 * TOUCH_SAMPLING_PIN_3)) | (2 << (2 * TOUCH_CHANNEL_7_PIN)) | \
                                (2 << (2 * TOUCH_CHANNEL_8_PIN)));
  TOUCH_GROUP_3_GPIO->AFR[0] |= (TOUCH_AF << (4 * TOUCH_SAMPLING_PIN_3)) | (TOUCH_AF << (4 * TOUCH_CHANNEL_7_PIN)) | \
                                (TOUCH_AF << (4 * TOUCH_CHANNEL_8_PIN));
  
  RCC->AHBENR |= RCC_AHBENR_TSCEN;
  
  TSC->CR = (4 << 12) | (1 << 28) | (1 << 24) | \
            TSC_CR_MCV_1 | TSC_CR_MCV_2 | TSC_CR_TSCE;
  
  TSC->IOHCR &= ~(TSC_IOHCR_G1_IO1 | TSC_IOHCR_G1_IO2 | TSC_IOHCR_G1_IO3 | TSC_IOHCR_G1_IO4 | \
                  TSC_IOHCR_G2_IO1 | TSC_IOHCR_G2_IO2 | TSC_IOHCR_G2_IO3 | TSC_IOHCR_G2_IO4 | \
                  TSC_IOHCR_G5_IO1 | TSC_IOHCR_G5_IO2 | TSC_IOHCR_G5_IO3);
  TSC->IER = TSC_IER_EOAIE;
  TSC->IOSCR = TSC_IOSCR_G1_IO1 | TSC_IOSCR_G2_IO1 | TSC_IOSCR_G5_IO1;
  TSC->IOCCR = TSC_IOCCR_G5_IO2;//TSC_IOCCR_G1_IO2;
  TSC->IOGCSR = TSC_IOGCSR_G5E;//TSC_IOGCSR_G1E;
  NVIC_SetPriority(TSC_IRQn, 1);
  NVIC_EnableIRQ(TSC_IRQn);
  
  Mode = (GPIOA->IDR & ((1 << CONFIG_1_PIN) | (1 << CONFIG_2_PIN))) >> CONFIG_1_PIN;
  TSC->CR |= TSC_CR_START;
}
//------------------------------------------------------------------------------
void Sensor_IRQ()
{
  if((TSC->ISR & TSC_ISR_EOAF) == TSC_ISR_EOAF)
  {
    static uint8_t TouchChnlCnt = 0;
    static uint8_t TouchState = 0;
    static uint16_t PressCnt[TOUCH_CHANNELS_NUM] = {0,0,0,0,0,0,0,0,};
    
    TSC->ICR |= TSC_ICR_EOAIC;
    
    uint32_t TouchChnl[TOUCH_CHANNELS_NUM] = { TSC_IOCCR_G5_IO2, TSC_IOCCR_G5_IO3,
                                               TSC_IOCCR_G1_IO2, TSC_IOCCR_G1_IO3, TSC_IOCCR_G1_IO4,
                                               TSC_IOCCR_G2_IO2, TSC_IOCCR_G2_IO3, TSC_IOCCR_G2_IO4,
                                               };
    
    GPIO_TypeDef *GPIOs[TOUCH_CHANNELS_NUM] = {OUT_7_GPIO, OUT_8_GPIO, OUT_1_GPIO, OUT_2_GPIO, OUT_3_GPIO, OUT_4_GPIO, OUT_5_GPIO, OUT_6_GPIO, };
    uint16_t PINs[TOUCH_CHANNELS_NUM] = {OUT_7_PIN, OUT_8_PIN, OUT_1_PIN, OUT_2_PIN, OUT_3_PIN, OUT_4_PIN, OUT_5_PIN, OUT_6_PIN,  };
    
    uint32_t TouchREG;
    if (TouchChnlCnt < 2)
      TouchREG = TSC->IOGXCR[4];
    else if (TouchChnlCnt < 5)
      TouchREG = TSC->IOGXCR[0];
    else
      TouchREG = TSC->IOGXCR[1];
    

    if (Mode == 3)    
    {
      if(TouchREG <= TOUCH_THRESHOLD)
        GPIOs[TouchChnlCnt]->ODR &= ~(1 << PINs[TouchChnlCnt]);
      else
        GPIOs[TouchChnlCnt]->ODR |= (1 << PINs[TouchChnlCnt]);
    }
    
    else if (Mode == 2)
    {
      if(TouchREG <= TOUCH_THRESHOLD)
      {
        if (PressCnt[TouchChnlCnt] < 15)
          PressCnt[TouchChnlCnt]++;
      
        if (PressCnt[TouchChnlCnt] == 10)
        {
        //PressCnt[TouchChnlCnt] = 0;
          if ((TouchState & (1 << TouchChnlCnt)) == (1 << TouchChnlCnt))
          {
            TouchState &= ~(1 << TouchChnlCnt);
            GPIOs[TouchChnlCnt]->ODR |= (1 << PINs[TouchChnlCnt]);
          }
          else
          {
            TouchState |= (1 << TouchChnlCnt);
            GPIOs[TouchChnlCnt]->ODR &= ~(1 << PINs[TouchChnlCnt]);
          }
        }
      }
    
      else
        PressCnt[TouchChnlCnt] = 0;
    }
    
    else if (Mode == 1)
    {
      if(TouchREG <= TOUCH_THRESHOLD)
      {
        for (uint8_t i = 0; i < TOUCH_CHANNELS_NUM; i++)
          GPIOs[i]->ODR |= (1 << PINs[i]);
        
        GPIOs[TouchChnlCnt]->ODR &= ~(1 << PINs[TouchChnlCnt]);
      }
    }
    
    else
    {
      if(TouchREG <= TOUCH_THRESHOLD)
      {
        if (TouchChnlCnt == 0)
        {
          if (PressCnt[TouchChnlCnt] < 15)
            PressCnt[TouchChnlCnt]++;
          
          if (PressCnt[TouchChnlCnt] == 10)
          {        
            if ((TouchState & (1 << TouchChnlCnt)) == (1 << TouchChnlCnt))
            {
              TouchState &= ~(1 << TouchChnlCnt);
              GPIOs[TouchChnlCnt]->ODR |= (1 << PINs[TouchChnlCnt]);
            }
            else
            {
              for (uint8_t i = 0; i < TOUCH_CHANNELS_NUM; i++)
                GPIOs[i]->ODR |= (1 << PINs[i]);
              
              TouchState |= (1 << TouchChnlCnt);
              GPIOs[TouchChnlCnt]->ODR &= ~(1 << PINs[TouchChnlCnt]);
            }
          }
        }
        
        else
        {
          for (uint8_t i = 0; i < TOUCH_CHANNELS_NUM; i++)
            GPIOs[i]->ODR |= (1 << PINs[i]);
          
          TouchState &= ~(1 << 0);
          
          for (uint8_t i = 0; i <= TouchChnlCnt; i++)
            GPIOs[i]->ODR &= ~(1 << PINs[i]);
        }
      }
      
      else if (TouchChnlCnt == 0)
        PressCnt[TouchChnlCnt] = 0;
    }
    
    TouchChnlCnt++;
    if (TouchChnlCnt == TOUCH_CHANNELS_NUM)
    {
      TouchChnlCnt = 0;
    }
    TSC->IOCCR = TouchChnl[TouchChnlCnt];
    
    if (TouchChnlCnt < 2)
      TSC->IOGCSR = TSC_IOGCSR_G5E;
    else if (TouchChnlCnt < 5)
      TSC->IOGCSR = TSC_IOGCSR_G1E;
    else
      TSC->IOGCSR = TSC_IOGCSR_G2E;
    
/*    
    if (TouchChnlCnt < 3)
      TSC->IOGCSR = TSC_IOGCSR_G1E;
    else if (TouchChnlCnt < 6)
      TSC->IOGCSR = TSC_IOGCSR_G2E;
    else
      TSC->IOGCSR = TSC_IOGCSR_G5E;
    */
    TSC->CR |= TSC_CR_START;
  }
}


